//+---------------------------------------------------------------------+
//|                                           cc-sign.mq4               |
//|                                    by finimej on 2009-09-04         |     
//|the original complex-pair indicator is made by Simeon Semenych on 
//| http://articles.mql4.com/484.
//|Description:
//|How to use it? please refer to the nice artical by Simeon Semenych 
//| on http://articles.mql4.com/484.
//|This updated version added:
//|1) show buy and sell signal and draw lines help you to make the decision.
//+---------------------------------------------------------------------+
#property copyright "finimej"
#property link      "www.formulatrader.com"
//----
#property indicator_separate_window
#property  indicator_level1  0
#property indicator_levelcolor DarkSlateGray
#property indicator_buffers 5
#property indicator_color1 Chocolate
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red
extern string SignalbarExplained="Signalbar=0 signal on current bar, Signalbar=1, signal on last bar";
extern int Signalbar=1;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double offset=0.0;
string indicatorname;
//---- parameters
// for monthly
int mn_per = 12;
int mn_fast = 3;
// for weekly
int w_per = 9;
int w_fast = 3;
// for daily
int d_per = 5;
int d_fast = 3;
// for H4
int h4_per = 12;
int h4_fast = 2;
// for H1
int h1_per = 24;
int h1_fast = 8;
// for M30
int m30_per = 16;
int m30_fast = 2;
// for M15
int m15_per = 16;
int m15_fast = 4;
// for M5
int m5_per = 12;
int m5_fast = 3;
// for M1
int m1_per = 30;
int m1_fast = 10;
   int per1, per2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  switch(Period())
     {
       case 1:     per1 = m1_per;  per2 = m1_fast;  offset=0.00008; break;
       case 5:     per1 = m5_per;  per2 = m5_fast;  offset=0.0004; break;
       case 15:    per1 = m15_per; per2 = m15_fast; offset=0.0006; break;
       case 30:    per1 = m30_per; per2 = m30_fast; offset=0.0012;break;
       case 60:    per1 = h1_per;  per2 = h1_fast;  offset=0.0012;break;
       case 240:   per1 = h4_per;  per2 = h4_fast;  offset=0.002;break;
       case 1440:  per1 = d_per;   per2 = d_fast;   offset=0.0025;break;
       case 10080: per1 = w_per;   per2 = w_fast;   offset=0.01;break;
       case 43200: per1 = mn_per;  per2 = mn_fast; offset=0.01; break;
     }
//---- indicators
   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID, 2);
   SetIndexBuffer(0, ExtMapBuffer1);
   indicatorname="ComplexPairSignal_" + Symbol() + "(" + Period() + ")";
   IndicatorShortName(indicatorname);
   SetIndexLabel(0, Symbol()); 
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID, 2);
   SetIndexArrow(1,242);SetIndexLabel(1,"S");
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW,STYLE_SOLID, 2);
   SetIndexArrow(2,241);SetIndexLabel(2,"B");
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW,STYLE_SOLID, 2);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW,STYLE_SOLID, 2);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
     ObjectsDeleteAll(1, OBJ_TREND); 
     ObjectsRedraw();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int k,limit;
   double ccc1,ccc2,ccc3;
   int pos1,pos2,pos3,pos4;
   double y1,y2,y3,y4;
   double y_DW,y_DW1,y_DW2,yUP,yUP1,yUP2;
   int counted_bars = IndicatorCounted();

   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars -= 10;
   limit = Bars - counted_bars;
   int Price = 6;
   int Mode = 3;
   
   for(int i = 0; i < limit; i++)
     {
       ExtMapBuffer1[i] = GetCC(Mode, per1, per2,i);
       
         ccc1=GetCC(Mode, per1, per2,i+1);
         ccc2=GetCC(Mode, per1, per2,i+2);
         ccc3=GetCC(Mode, per1, per2,i+3);
           if  (ccc1<ccc2 && ccc2>ccc3) ExtMapBuffer5[i+2]=ccc2; //turn of tops
         if  (ccc1>ccc2 && ccc2<ccc3) ExtMapBuffer4[i+2]=ccc2; //turn of bottens
     }
    //------ Search tops------
    k=0;
    for (i=0; i<500; i++)
      {
         if (ExtMapBuffer5[i]>0 && k==0) { y1=ExtMapBuffer5[i]; pos1=i; k++;}
         if (ExtMapBuffer5[i]>0.001 && ExtMapBuffer5[i]>y1 && k!=0) { y2=ExtMapBuffer5[i]; pos2=i; k++;}
         if (k>1) break;
      }
     //----- search bottoms ------
    k=0;
   for (i=0; i<500; i++)
      {
         if (ExtMapBuffer4[i]<0 && ExtMapBuffer4[i]!=0 && k==0) { y3=ExtMapBuffer4[i]; pos3=i; k++;}
         if (ExtMapBuffer4[i]!=0 && ExtMapBuffer4[i]<0.001 && ExtMapBuffer4[i]<y3 && k!=0) { y4=ExtMapBuffer4[i]; pos4=i; k++;}
         if (k>1) break;
      }
    
     ccc1=GetCC(Mode, per1, per2,Signalbar);
     ccc2=GetCC(Mode, per1, per2,Signalbar+1);

      if (y3!=0 && y4!=0)
      {
      //line extention to point y3 and y4 (from bottom points), called buy line     
      y_DW=y3+((pos3)*(y3-y4)/(pos4-pos3));
      y_DW1=y3+((pos3-Signalbar)*(y3-y4)/(pos4-pos3));
      y_DW2=y3+((pos3-Signalbar-1)*(y3-y4)/(pos4-pos3));
      }      
      // if ccline cross the buyline upperfrom, then it is sell signal   
      if (y_DW!=0 && ccc1<y_DW1 && ccc2>y_DW2 ) {ExtMapBuffer2[0]=y_DW+offset; // Signal Sell
                                       Alert ("SELL !!!");}
      //line extention to point y1 and y2 (from top points), called sell line     
      if (y1!=0 && y2!=0) 
		{
		yUP=y1+(pos1*(y1-y2)/(pos2-pos1));
		yUP1=y1+((pos1-Signalbar)*(y1-y2)/(pos2-pos1));
		yUP2=y1+((pos1-Signalbar-1)*(y1-y2)/(pos2-pos1));
		}
		//if the line cross the sell line under from, then it is buy signal
		if (yUP!=0 && ccc1>yUP1 && ccc2<yUP2 ) {ExtMapBuffer3[0]=yUP-offset; // Signal Buy
		                                       Alert ("BUY !!!");}       
		ExtMapBuffer2[pos2]=GetCC(Mode, per1, per2,pos2)+offset;
		ExtMapBuffer2[pos1]=GetCC(Mode, per1, per2,pos1)+ offset;
      ExtMapBuffer3[pos3]=GetCC(Mode, per1, per2,pos3)-offset;
		ExtMapBuffer3[pos4]=GetCC(Mode, per1, per2,pos4)-offset;
      
      ObjectsDeleteAll(WindowFind(indicatorname), OBJ_TREND); 
      ObjectsRedraw();
   
      ObjectCreate("Sell",OBJ_TREND,WindowFind(indicatorname),Time[pos2],y2,Time[pos1],y1); 
		ObjectSet("Sell",OBJPROP_COLOR,Red); 
		ObjectSet("Sell",OBJPROP_WIDTH,1); 
		ObjectSet("Sell",OBJPROP_STYLE,STYLE_SOLID);

		ObjectCreate("Buy",OBJ_TREND,WindowFind(indicatorname),Time[pos4],y4,Time[pos3],y3); 
		ObjectSet("Buy",OBJPROP_COLOR,Blue); 
		ObjectSet("Buy",OBJPROP_WIDTH,1); 
		ObjectSet("Buy",OBJPROP_STYLE,STYLE_SOLID);
	
		if (pos1>pos3)
   	        ObjectCreate("Signal",OBJ_TREND,WindowFind(indicatorname),Time[pos1],y1,Time[pos3],y3); 
   	else
   	        ObjectCreate("Signal",OBJ_TREND,WindowFind(indicatorname),Time[pos3],y3,Time[pos1],y1); 
  
		ObjectSet("Signal",OBJPROP_COLOR,Green); 
		ObjectSet("Signal",OBJPROP_WIDTH,1); 
		ObjectSet("Signal",OBJPROP_STYLE,STYLE_SOLID);
    
   RefreshRates();
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double pp(int Mode, int Price,int per1, int per2, int i)
  {
   return((iMA(Symbol(), 0, per2, 0, Mode,Price, i)-
           iMA(Symbol(), 0, per1, 0, Mode,Price, i)));
  }   
//+------------------------------------------------------------------+

double GetCC(int Mode, int per1, int per2, int i)
{    double OPEN, HIGH, LOW, CLOSE;     
       OPEN = pp(Mode, PRICE_OPEN, per1, per2, i);
       HIGH = pp(Mode, PRICE_HIGH, per1, per2,i);
       LOW = pp(Mode, PRICE_LOW, per1, per2,i);
       CLOSE = pp(Mode, PRICE_CLOSE, per1, per2,i);
       return( (OPEN + HIGH + LOW + CLOSE) / 4);
 }     
 
  